VERSION 5.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   ClientHeight    =   5595
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6885
   FillColor       =   &H00808080&
   FillStyle       =   0  'Solid
   LinkTopic       =   "Form1"
   PaletteMode     =   2  'Custom
   ScaleHeight     =   260
   ScaleMode       =   0  'User
   ScaleWidth      =   260
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      BackColor       =   &H8000000E&
      Caption         =   "Tunnels + by Robert Rayment"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000080FF&
      Height          =   300
      Left            =   135
      TabIndex        =   0
      Top             =   180
      Width           =   2415
   End
   Begin VB.Menu Types 
      Caption         =   "Tunnels"
      Begin VB.Menu Tunnel 
         Caption         =   "Tunnel"
      End
      Begin VB.Menu RibbedTunnel 
         Caption         =   "Ribbed Tunnel"
      End
      Begin VB.Menu Bitty 
         Caption         =   "BittyTunnel"
      End
      Begin VB.Menu EllipticalTunnel 
         Caption         =   "Elliptical Tunnel"
      End
      Begin VB.Menu RectangleTunnel 
         Caption         =   "Rectangle Tunnel"
      End
      Begin VB.Menu BentTunnel 
         Caption         =   "Bent Tunnel"
      End
   End
   Begin VB.Menu Things 
      Caption         =   "Things"
      Begin VB.Menu Bubbly 
         Caption         =   "Bubbly"
      End
      Begin VB.Menu MMXScrollUp 
         Caption         =   "MMX Scroll up"
      End
      Begin VB.Menu MMXScrollDown 
         Caption         =   "MMX Scroll down"
      End
      Begin VB.Menu MMXLeftScroll 
         Caption         =   "MMX Left scroll"
      End
      Begin VB.Menu MMXRightScroll 
         Caption         =   "MMX Right scroll"
      End
      Begin VB.Menu SunsetBMP 
         Caption         =   "SunsetBMP"
      End
      Begin VB.Menu Size256x256 
         Caption         =   "Size 256x256"
      End
      Begin VB.Menu Size640x480 
         Caption         =   "Size 640x480"
      End
      Begin VB.Menu Plasma 
         Caption         =   "Plasma"
      End
      Begin VB.Menu Fire 
         Caption         =   "Fire"
      End
   End
   Begin VB.Menu Palette 
      Caption         =   "Palette"
      Begin VB.Menu PALAir 
         Caption         =   "Grey"
      End
      Begin VB.Menu PALStep7 
         Caption         =   "Step7"
      End
      Begin VB.Menu PALDemo 
         Caption         =   "Demo"
      End
      Begin VB.Menu PALSin 
         Caption         =   "Sin"
      End
      Begin VB.Menu Newton 
         Caption         =   "Newton"
      End
      Begin VB.Menu Earth 
         Caption         =   "Earth"
      End
      Begin VB.Menu FirePal 
         Caption         =   "Fire"
      End
      Begin VB.Menu Gamma1 
         Caption         =   "Gamma"
      End
      Begin VB.Menu Girl 
         Caption         =   "Girl"
      End
      Begin VB.Menu Mandel 
         Caption         =   "Mandel"
      End
      Begin VB.Menu Moon 
         Caption         =   "Moon"
      End
      Begin VB.Menu Pale2 
         Caption         =   "Pale"
      End
      Begin VB.Menu Halfsine 
         Caption         =   "Halfsine"
      End
      Begin VB.Menu Sunset 
         Caption         =   "Sunset"
      End
   End
   Begin VB.Menu KeyR90 
      Caption         =   "&Rotate 90"
   End
   Begin VB.Menu ClearForm 
      Caption         =   "&Clear"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Tunnel.frm

'Tunnels & Things  by  Robert Rayment 13/2/01

'This just demonstrates a tiny number of the possibilities
'for these techniques.  It is highly flexible only limited
'by one's imagination.

'Uses a bit of MMX - note I haven't tested for this but
'nearly all PCs have it nowadays.

'This program draws to a 256x256(8) drawing surface byte array
'and transfers it to the Form with StretchDIBits.
'There's also a Render surface that I haven't used yet.
'The advantage of StretchDIBits is that it
'can take a pointer to the drawing surface and
'to a palette.  This allows the palettes to be
'changed on the fly.  Also its very fast in transferring
'to resized Forms.

'Drawing to the byte array consists of placing color
'indexes into each byte which then act as pointers into
'a 256 color palette (very like direct screen addressing in DOS).
'VB is used for drawing to the surface and assembler (with a couple
'of MMX codes) for animation.

'Further info on the assembler stuff can be found in
'VB, Assembler & Resource files' on PSC.  All the machine
'code and palettes could be put in a resource file but its
'easier for messying about to have all the bits out!

'----------------------------------------------------------------
'The sub RunCode OpCode&, SurfPtr& passes ByVal OpCode&(Long)
'to the mcode for running different bits of code and SurfPtr&
'telling StretchDIBits which surface to use.

'OpCode& Surface  Type
'1       Draw     Tunnel
'1       Draw     RibbedTunnel
'1       Draw     Bitty tunnel
'1       Draw     EllipticalTunnel
'1       Draw     RectangleTunnel
'1       Draw     BentTunnel
'2       Draw     Bubbly
'4       Draw     MMX Scroll Up
'8       Draw     MMX Scroll Down
'16      Draw     MMX Scroll Left
'32      Draw     MMX Scroll Right
'        Draw     Sunset.BMP
'1       Draw     Plasma
'64      Draw     Fire

'----------------------------------------------------------------

'Rotation through 90 degrees is done in pure VB (of course
'only shows effect for non-circular patterns).

'The palette files are from all over the place, some I've made
'and others from 8-bit bitmaps.  Make your own.

'----------------------------------------------------------------

Option Base 1

DefInt A-T
DefSng U-Z

'NB Dont use Option Explicit on my progs. Defs plus VB's
'own type declarations are far superior.  I can go to any
'point in my progs and know immediately what type of variable
'I'm dealing with without having to troll back through a lot
'of useless Dims!!  Unfortunately I think VB NET insists on
'Option Explicit  - definitely a step backwards?!


'Tunnel.bas things:-
'Constants for StretchDIBits
'Public Const DIB_RGB_COLORS = 0
'Public Const SRCCOPY = &HCC0020

''Byte drawing surface
'Global DrawSurf() As Byte
''Byte rendering surface
'Global RendSurf() As Byte
'Global PathSpec$        'App path
'Global PalSpec$         'PAL file
'Global InCode() As Byte 'To hold mcode

Dim Done As Boolean  'To exit loop
Dim zcount 'Fire Randomization counter


Private Sub FirePal_Click()
PalSpec$ = PathSpec$ & "Fire.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Form_Load()

KeyPreview = True

'Set form up
ScaleMode = vbPixels
WindowState = vbNormal
AutoRedraw = False
Top = 1000
Left = 1000

Width = 640 * Screen.TwipsPerPixelX    'ie * 15
Height = 480 * Screen.TwipsPerPixelY   'ie * 15

Caption = Str$(X) + Str$(Y) & "      Maximize -->"

'Get app path
PathSpec$ = App.Path
If Right$(PathSpec$, 1) <> "\" Then PathSpec$ = PathSpec$ & "\"

PalSpec$ = PathSpec$ & "Halfsine.PAL"   'Default palette
ReadPAL PalSpec$

ReDim DrawSurf(256, 258)  'Edged Drawing byte surface
ReDim RendSurf(256, 256)  'Rendering byte surface

For iy = 1 To 100
For ix = 1 To 100
   RendSurf(ix, iy) = ix + iy
Next ix
Next iy

'Fill BITDATA structure for machine code
bmp.bmWidth = 256          'Pixel width
bmp.bmHeight = 256         'Pixel height
bmp.ptrDrawSurf = VarPtr(DrawSurf(1, 2))  'Pointer to drawing surface LINE 2
bmp.ptrRendSurf = VarPtr(RendSurf(1, 1))  'Pointer to rendering surface


'Fill BITMAPINFO.BITMAPINFOHEADER FOR StretchDIBits
bm.bmiH.biSize = 40
bm.bmiH.biwidth = bmp.bmWidth
bm.bmiH.biheight = bmp.bmHeight
bm.bmiH.biPlanes = 1
bm.bmiH.biBitCount = 8
bm.bmiH.biCompression = 0
bm.bmiH.biSizeImage = 0 'not used here
bm.bmiH.biXPelsPerMeter = 0
bm.bmiH.biYPelsPerMeter = 0
bm.bmiH.biClrUsed = 0
bm.bmiH.biClrImportant = 0

'Load mcode
InFile$ = PathSpec$ & "TunInc.bin"
Loadmcode (InFile$)

End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Caption = Str$(X) + Str$(Y) & "      Maximize -->"

End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
If KeyAscii = Asc("R") Or KeyAscii = Asc("r") Then KeyR90_Click
If KeyAscii = Asc("C") Or KeyAscii = Asc("c") Then
   Done = True
   Cls
End If
End Sub


Private Sub KeyR90_Click()
   
   Rotate90
   
   ShowDrawSurfOnce

End Sub

Private Sub ClearForm_Click()
   Done = True
   Cls
End Sub

Private Sub Form_Unload(Cancel As Integer)
'Over-done exit !!?
Done = True    'end loop
Erase DrawSurf, RendSurf
DoEvents
Unload Me
End
End Sub

'### PALETTES ###########################################################

Private Sub Earth_Click()
PalSpec$ = PathSpec$ & "Earth.PAL"
ReadPAL PalSpec$
End Sub


Private Sub Gamma1_Click()
PalSpec$ = PathSpec$ & "Gamma1.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Girl_Click()
PalSpec$ = PathSpec$ & "Girl.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Halfsine_Click()
PalSpec$ = PathSpec$ & "Halfsine.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Mandel_Click()
PalSpec$ = PathSpec$ & "Mandel.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Moon_Click()
PalSpec$ = PathSpec$ & "Moon.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Newton_Click()
PalSpec$ = PathSpec$ & "Newton.PAL"
ReadPAL PalSpec$
End Sub

Private Sub PALAir_Click()
PalSpec$ = PathSpec$ & "Air.PAL"
ReadPAL PalSpec$
End Sub

Private Sub PALDemo_Click()
PalSpec$ = PathSpec$ & "Demo.PAL"
ReadPAL PalSpec$
End Sub

Private Sub Pale2_Click()
PalSpec$ = PathSpec$ & "Pale2.PAL"
ReadPAL PalSpec$
End Sub

Private Sub PALSin_Click()
PalSpec$ = PathSpec$ & "Sine.PAL"
ReadPAL PalSpec$
End Sub

Private Sub PALStep7_Click()
PalSpec$ = PathSpec$ & "Step7.PAL"
ReadPAL PalSpec$
End Sub



Private Sub Sunset_Click()
PalSpec$ = PathSpec$ & "Sunset.PAL"
ReadPAL PalSpec$
End Sub



'### TUNNELS ############################################################
'OpCode
'1       Tunnel
'1       RibbedTunnel
'1       Bitty tunnel
'1       EllipticalTunnel
'1       RectangleTunnel
'1       BentTunnel

Private Sub Tunnel_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"): Form_Unload 1

'Fill DrawSurf with radii == color number
'Simple set of circles
For iy = 1 To 258
For ix = 1 To 256
   rad = Int(Sqr((ix - 128) ^ 2 + (iy - 128) ^ 2))
   rad = rad And &HFF
   If rad < 10 Then rad = 0
   DrawSurf(ix, iy) = rad
Next ix
Next iy

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub RibbedTunnel_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"):  Form_Unload 1

'Fill DrawSurf with circle radii == color number
'Simple set of circles
For iy = 1 To 258
For ix = 1 To 256
   rad = Int(Sqr((ix - 128) ^ 2 + (iy - 128) ^ 2))
   rad = rad And &HFF
   If rad < 10 Then rad = 0
   DrawSurf(ix, iy) = rad
Next ix
Next iy

'Put on radial ribs
For zztheta = 0 To 2 * pi# Step 0.2
For ztheta = zztheta To zztheta + 0.05 Step 0.005
For rad = 180 To 10 Step -1
   ix = 128 + rad * Cos(ztheta)
   ix = (ix And &HFF) + 1
   
   ixp = 128 + (rad - 1) * Cos(ztheta)
   ixp = (ixp And &HFF) + 1
   
   iy = 128 + rad * Sin(ztheta)
   If iy < 1 Then iy = 1
   If iy > 258 Then iy = 258
   
   iyp = 128 + (rad - 1) * Sin(ztheta)
   If iyp < 1 Then iyp = 1
   If iyp > 258 Then iyp = 258
   
   DrawSurf(ix, iy) = DrawSurf(ixp, iyp)

Next rad
Next ztheta
Next zztheta

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub EllipticalTunnel_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"):  Form_Unload 1

'Fill DrawSurf with color num=sqr(a^2-b^2) & a=2*b
'Simple set of ellipses
For iy = 1 To 258
For ix = 1 To 256
   zdx = (ix - 128)
   zdy = (iy - 128)
   cul = Int(Sqr(zdy ^ 2 + (zdx ^ 2) / 4)) And &HFF
   DrawSurf(ix, iy) = cul
Next ix
Next iy

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub Bitty_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"):  Form_Unload 1

Randomize
'Fill DrawSurf with radii == color number
'Circles plus some randomisation
For iy = 1 To 258
For ix = 1 To 256
   rad = Int(Sqr((ix - 128) ^ 2 + (iy - 128) ^ 2))
   rad = rad And &HFF
   If rad < 10 Then rad = 0
   DrawSurf(ix, iy) = rad
Next ix
Next iy
For i = 1 To 2
For iy = 3 To 256
For ix = 3 To 254
   cul = DrawSurf(ix, iy)
   cul = cul + DrawSurf(ix - 1, iy)
   cul = cul + DrawSurf(ix + 1, iy)
   cul = cul + DrawSurf(ix, iy - 1)
   cul = cul + DrawSurf(ix, iy + 1)
   
   
   cul = cul + DrawSurf(ix - 2, iy)
   cul = cul + DrawSurf(ix + 2, iy)
   cul = cul + DrawSurf(ix, iy - 2)
   cul = cul + DrawSurf(ix, iy + 2)
   
   cul = cul + Rnd * 10
   cul = cul \ 9
   cul = cul And &HFF
   DrawSurf(ix, iy) = cul
Next ix
Next iy
Next i

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub RectangleTunnel_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"): Form_Unload 1
cul = 250

'Simple set of rectangles
For iy = 1 To 128
   For ix = iy To 257 - iy
      DrawSurf(ix, iy) = cul
   Next ix
   ix = iy
   For iyy = iy To 258 - iy
      DrawSurf(ix, iyy) = cul
   Next iyy
   iyy = 258 - iy
   For ix = iy To 257 - iy
      DrawSurf(ix, iyy) = cul
   Next ix
   ix = 257 - iy
   For iyy = 258 - iy To iy Step -1
      DrawSurf(ix, iyy) = cul
   Next iyy
   cul = cul - 1
Next iy

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub BentTunnel_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"): Form_Unload 1

On Error Resume Next
'NB x..,y..,z..  are Real

'Bent bit
ix1 = 256 / 4: ix2 = 3 * 256 / 4
iy1 = 256 / 4: iy2 = 3 * 256 / 4
zL = ix2 - ix1
ztana = Tan((zL / 2) / (zL - 1))
cul = 100
For ixL = ix1 + 1 To ix2 - 1
    yd = (ixL - ix1) * ztana
    iyT = iy1 + yd
    iyB = iy2 - yd
    If iyT >= iyB Then Exit For
    For ix = ixL To ix2 - 1
        DrawSurf(ix, iyT) = cul
        DrawSurf(ix, iyB) = cul
    Next ix
    For iy = iyT To iyB
        DrawSurf(ixL, iy) = cul
    Next iy
    cul = cul - 1
Next ixL

'Rest of tunnel
cul = 101
ixR = ix1 + (ix2 - ix1)
For ixL = ix1 To 1 Step -1
   iyT = ixL
   iyB = ixR
   For ix = ixL To ixR
        DrawSurf(ix, iyT) = cul
        DrawSurf(ix, iyB) = cul
   Next ix
   For iy = iyT To iyB
        DrawSurf(ixL, iy) = cul
        DrawSurf(ixR, iy) = cul
   Next iy
   cul = cul + 1
   If cul > 255 Then cul = 1
   ixR = ixR + 1
Next ixL

RunCode 1&, bmp.ptrDrawSurf

End Sub

'### THINGS ##############################################################

'OpCode
'2    Bubbly
'4    MMX Scroll Up
'8    MMX Scroll Down
'16   MMX Scroll Left
'32   MMX Scroll Right
'     Sunset
'1    Plasm
'64   Fire

Private Sub Bubbly_Click()
Done = True    'end loop for re-starts
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"):  Form_Unload 1

'Fill DrawSurf with circle radii == color number
'Any shape ends up as bubbles!
For iy = 1 To 258
For ix = 1 To 256
   rad = Int(Sqr((ix - 128) ^ 2 + (iy - 128) ^ 2))
   rad = rad And &HFF
   If rad < 10 Then rad = 0
   DrawSurf(ix, iy) = rad
Next ix
Next iy

'Note OpCode& = 2&
RunCode 2&, bmp.ptrDrawSurf
End Sub

Private Sub MMXScrollUp_Click()
Done = True    'end loop for re-starts
'Note OpCode& = 4&
RunCode 4&, bmp.ptrDrawSurf
End Sub

Private Sub MMXScrollDown_Click()
Done = True    'end loop for re-starts
'Note OpCode& = 8&
RunCode 8&, bmp.ptrDrawSurf
End Sub

Private Sub MMXLeftScroll_Click()
Done = True    'end loop for re-starts
'Note OpCode& = 16&
RunCode 16&, bmp.ptrDrawSurf
End Sub

Private Sub MMXRightScroll_Click()
Done = True    'end loop for re-starts
'Note OpCode& = 32&
RunCode 32&, bmp.ptrDrawSurf
End Sub

Private Sub SunsetBMP_Click()

'LOAD AN 8-BIT BMP THROUGH DrawSurf()

Done = True

Dim bpp As Byte

BMPSpec$ = PathSpec$ & "Sunset.bmp"

Open BMPSpec$ For Binary As #2
   
Seek #2, 29    'bits per pixel
Get #2, , bpp
If bpp <> 8 Then
   res = MsgBox("Not a 256 color 8-bit BMP")
   Close
   Exit Sub
End If

PalSpec$ = PathSpec$ & "Sunset.PAL"
ReadPAL PalSpec$     'NB Uses file #1

Seek #2, 1079  'start of picture color indices
Get #2, , DrawSurf   'load
Close #2

ShowDrawSurfOnce

End Sub

Private Sub Size256x256_Click()
On Error GoTo max256 'Resume Next 'NB Can't resize when maximizes or minimised
Width = 260 * Screen.TwipsPerPixelX    'ie * 15
Height = 260 * Screen.TwipsPerPixelY   'ie * 15
ShowDrawSurfOnce
Exit Sub
'==========
max256:
res = MsgBox("Maximised picture, Press resize button first")
Exit Sub
End Sub

Private Sub Size640x480_Click()
On Error GoTo max640 'Resume Next 'NB Can't resize when maximizes or minimised
Width = 640 * Screen.TwipsPerPixelX    'ie * 15
Height = 480 * Screen.TwipsPerPixelY   'ie * 15
ShowDrawSurfOnce
'Needs to be done twice for static BMP it seems??
DoEvents
ShowDrawSurfOnce
Exit Sub
'==========
max640:
res = MsgBox("Maximised picture, Press resize button first")
Exit Sub
End Sub

Private Sub Plasma_Click()

'Non-recursive plasm generator for a 256x256 (ie 2^8 x 2^8)
'byte array
'NB Not perfect tends to migrate a bit from a corner

Done = True    'end RunCode looping

Dim cul As Byte
Randomize

MousePointer = vbHourglass
'Set 4 outer corners to random color numbers
cul = 255 * Rnd: RendSurf(1, 1) = cul
cul = 255 * Rnd: RendSurf(256, 1) = cul
cul = 255 * Rnd: RendSurf(1, 256) = cul
cul = 255 * Rnd: RendSurf(256, 256) = cul

Roughness = 20  'Larger values increase randomness
                'If too large just get a speckly random pattern
For Lev = 2 To 8  '8 levels needed to cover the 256x256 surface
   NoSteps = 2 ^ Lev
   StepSize = 256 / NoSteps
   For iy = 1 To 257 Step StepSize
   For ix = 1 To 257 Step StepSize
      ix1 = ix: iy1 = iy
      ix2 = ix + StepSize: If ix2 > 256 Then ix2 = 256
      iy2 = iy + StepSize: If iy2 > 256 Then iy2 = 256
      If ix1 > 256 Then ix1 = 256
      If iy1 > 256 Then iy1 = 256
      'Left ix1
      iym = (iy1 + iy2) \ 2
      cul1 = RendSurf(ix1, iy1)
      cul2 = RendSurf(ix1, iy2)
      cula = (cul1 + cul2) \ 2 + Roughness * (Rnd - 0.5)
      RendSurf(ix1, iym) = cula And &HFF
      'Right ix2
      cul1 = RendSurf(ix2, iy1)
      cul2 = RendSurf(ix2, iy2)
      cula = (cul1 + cul2) \ 2 + Roughness * (Rnd - 0.5)
      RendSurf(ix2, iym) = cula And &HFF
      'Bottom  iy1
      ixm = (ix1 + ix2) \ 2
      cul1 = RendSurf(ix1, iy1)
      cul2 = RendSurf(ix2, iy1)
      cula = (cul1 + cul2) \ 2 + Roughness * (Rnd - 0.5)
      RendSurf(ixm, iy1) = cula And &HFF
      'Top iy2
      cul1 = RendSurf(ix1, iy2)
      cul2 = RendSurf(ix2, iy2)
      cula = (cul1 + cul2) \ 2 + Roughness * (Rnd - 0.5)
      RendSurf(ixm, iy2) = cula And &HFF
      'Center ixm,iym
      cul1 = RendSurf(ix1, iy1)
      cul2 = RendSurf(ix1, iy2)
      cul3 = RendSurf(ix2, iy1)
      cul4 = RendSurf(ix2, iy2)
      cula = (cul1 + cul2 + cul3 + cul4) \ 4 + Roughness * (Rnd - 0.5)
      RendSurf(ixm, iym) = cula And &HFF
   Next ix
   Next iy
Next Lev

'This is convenient for other operation on the plasma
CopyMemory DrawSurf(1, 2), RendSurf(1, 1), 256& * 256&

MousePointer = vbDefault

RunCode 1&, bmp.ptrDrawSurf

End Sub

Private Sub Fire_Click()
Done = True    'end loop for re-starts
PalSpec$ = PathSpec$ & "Fire.PAL"
ReadPAL PalSpec$
If PalSpec$ = "" Then MsgBox ("No palette file"): Form_Unload 1

ReDim DrawSurf(256, 258)  '0 it
ShowDrawSurfOnce

zcount = 0

RunCode 64&, bmp.ptrDrawSurf

End Sub

'### RUN MACHINE CODE & StretchDIBits ####################################

Private Sub RunCode(ByVal OpCode&, ByVal SurfPtr&)

'NB OpCode& = 1&, 2&, 4&, 8& etc determines which bits of
'code are run (see file TunnelRR.asm). I've only used 1& to
'64& so far.

'SurfPtr& tells StretchDIBits which surface to transfer to
'the form.

'Set CallWindowProc parameters
ptmc& = VarPtr(InCode(1))
ptbuff& = VarPtr(bmp.bmWidth)

Done = False   'stay in loop until Done = True

Do
   
   If OpCode& = 64 Then   'START & SEED FIRE with Fire.pal
      If zcount Mod 1 = 0 Then Randomize 'Slows flames down
      zcount = zcount + 1
      For iy = 1 To 2
      For ix = 1 To 256
         DrawSurf(ix, iy) = 255 * Rnd
      Next ix
      Next iy
   End If
   
   'Run mcode to cycle & render DrawSurf
   res& = CallWindowProc(ptmc&, ptbuff&, 2&, 3&, OpCode&)
   
   'Get Form dimensions in pixels
   FormWidth& = Me.Width \ Screen.TwipsPerPixelX
   FormHeight& = Me.Height \ Screen.TwipsPerPixelY
   
   'Stretch byte-array to Form
   'NB The ByVal is critical in this! Otherwise big memory leak!
   succ& = StretchDIBits(Me.hdc, _
   0, 0, _
   FormWidth& - 8, FormHeight& - 8, _
   0, 0, _
   256&, 256&, _
   ByVal SurfPtr&, bm, _
   DIB_RGB_COLORS, SRCCOPY)
      
   DoEvents

Loop While Done = False

End Sub

Private Sub ShowDrawSurfOnce()
'For showing BMP & instant Rotate90
   
   'Get Form dimensions in pixels
   FormWidth& = Me.Width \ Screen.TwipsPerPixelX
   FormHeight& = Me.Height \ Screen.TwipsPerPixelY
   
   'Stretch byte-array to Form
   'NB The ByVal is critical in this! Otherwise big memory leak!
   succ& = StretchDIBits(Me.hdc, _
   0, 0, _
   FormWidth& - 8, FormHeight& - 8, _
   0, 1, _
   256&, 256&, _
   ByVal bmp.ptrDrawSurf, bm, _
   DIB_RGB_COLORS, SRCCOPY)

End Sub

'KEYING STUFF NOT USED

'kleft = 37
'kright = 39
'kup = 38
'kdn = 40

'mright = Me.Width / Screen.TwipsPerPixelX
'pright = (pic1.Left + pic1.Width)
'mbot = Me.Height / Screen.TwipsPerPixelY
'pbot = (pic1.Top + pic1.Height)
'pstep = 2
'pstep2 = 8

'Select Case KeyCode
'Case kleft And Shift = 1
'   If pic1.Left > pstep2 Then pic1.Left = pic1.Left - pstep2
'Case kleft
'   If pic1.Left > pstep Then pic1.Left = pic1.Left - pstep

'Case kright And Shift = 1
'   If mright - pright > pstep2 Then
'      pic1.Left = pic1.Left + pstep2
'   End If
'Case kright
'   If mright - pright > pstep Then
'      pic1.Left = pic1.Left + pstep
'   End If

'Case kup And Shift = 1
'   If pic1.Top > pstep2 Then pic1.Top = pic1.Top - pstep2
'Case kup
'   If pic1.Top > pstep Then pic1.Top = pic1.Top - pstep

'Case kdn And Shift = 1
'   If mbot - pbot > pstep2 Then
'      pic1.Top = pic1.Top + pstep2
'   End If
'Case kdn
'   If mbot - pbot > pstep Then
'      pic1.Top = pic1.Top + pstep
'   End If
'End Select

